// TestCode.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include "math.h"
#include "malloc.h"
typedef signed char     IMG_BYTE;
typedef signed long     IMG_LWORD;
typedef unsigned char   IMG_UBYTE;
typedef unsigned long   IMG_ULWORD;
typedef float           IMG_REAL;
typedef double          IMG_LREAL;
typedef void            IMG_VVOID;
#define PI       3.14159265368
#undef	IMG_MIN 		/* Undefine IMG_MIN in PCIMGLIB header file */
#define IMG_MIN(x,y)	(((x) < (y)) ? (x):(y))
#ifdef __PHARLAP286__
        typedef signed int      IMG_WORD;
        typedef unsigned int    IMG_UWORD;
#else
        typedef signed short    IMG_WORD;
        typedef unsigned short  IMG_UWORD;
#endif
//#ifdef		_WIN64
//
//#define		asm_ax		rax
//#define		asm_bx		rbx
//#define		asm_dx		rdx
//#define		asm_si		rsi
//#define		asm_di		rdi
//
//#else
//
//#define		asm_ax		eax
//#define		asm_bx		ebx
//#define		asm_dx		edx
//#define		asm_si		esi
//#define		asm_di		edi
//
//#endif
#ifdef		_WIN64

#define		asm_ax		rax
#define		asm_bx		rbx
#define		asm_cx		rcx
#define		asm_dx		rdx
#define		asm_si		rsi
#define		asm_di		rdi
#define		ADDRESS_BIT		(3)

#else

#define		asm_ax		eax
#define		asm_bx		ebx
#define		asm_cx		ecx
#define		asm_dx		edx
#define		asm_si		esi
#define		asm_di		edi
#define		ADDRESS_BIT		(2)

#endif
typedef struct
{
    IMG_UWORD     x;
    IMG_UWORD     y;
} IMG_SIZE;
typedef struct
{
    IMG_WORD     x;
    IMG_WORD     y;
} IMG_COORD;
typedef struct
{
    IMG_UBYTE  *ptr;
    IMG_SIZE   size;
    IMG_UWORD  linestep; /* offset from one row of image buffer to
                            another on the same column in term of pixel */
} IMG_UBBUF;

typedef struct
{
    IMG_VVOID *ptr;
    IMG_SIZE  size;
    IMG_UWORD linestep;  /* offset from one row of image buffer to
                            another on the same column in term of pixel */
} IMG_VVBUF;
#define DSP_ERR_INVALID_ARG (-1)
#define SYS_BANK1_8     0x101
#define OK					0
#define IMG_FALSE			0
#define IMG_TRUE			0
#define SYS_BANK1_16    0x001
#define SYS_BANK1_8     0x101
/*------------------Bayer Filter---------------------------*/
#define DSP_BAYER_RGBG		(0)
#define DSP_BAYER_GRGB		(1)
#define DSP_BAYER_GBGR		(2)
#define DSP_BAYER_BGRG		(3)
#define DSP_BILINEAR_CBF	(0)
#define DSP_ADAPTIVE_CBF	(1)
#define		ATC_EAGLE_SSE			(0x1)
#define		ATC_EAGLE_CPU_FEATURE_FOR_SSE2		0x04000000
#define		ATC_EAGLE_CPU_FEATURE_FOR_MMX		0x00800000
static	IMG_UBYTE	ubSSE_MMX_Support=0x0ff;
//
#define BUF_OFF(pWorkptr, pBuf, pOff)							\
pWorkptr = ((pBuf)->ptr + IMG_OFF(pBuf,pOff));

#undef	IMG_OFF 			/* Undefine IMG_OFF in PCIMGLIB header file */
#define IMG_OFF(pBuf,pOff)	/*lint -e921 */ 								\
							( (IMG_LWORD)((IMG_LWORD)(pBuf)->linestep * 	\
							  (IMG_LWORD)(pOff)->y + (IMG_LWORD)(pOff)->x)) \
							/*lint -restore */

static	IMG_VVOID	Bilinear_RBG_TBBoundaryB_ub2w_SSE(	IMG_UBYTE	*pubS,
														IMG_UWORD	*puwD,
														IMG_LWORD	lwOpX)
{
	IMG_LWORD	i = 0, j;

	__asm
	{
		mov			ecx, lwOpX
		sar			ecx, 4
		jz			sse_over

		sal			ecx, 4
		mov			i, ecx
		sar			ecx, 4

		pcmpeqb		xmm7, xmm7
		pxor		xmm6, xmm6
		punpcklbw	xmm7, xmm6					// xmm7[0, 2, ..., 14] = ff, xmm7[1, 3, 5, ..., 15] = 0

		mov			asm_si, pubS
		mov			asm_di, puwD

sse_loop:
		movdqu		xmm0, [asm_si]
		add			asm_si, 16

		psrldq		xmm0, 1
		pand		xmm0, xmm7
		
		movdqa		[asm_di], xmm0
		add			asm_di, 16

		dec			ecx
		jnz			sse_loop

sse_over:
	}
	for( j = i >> 1, i++; i < lwOpX; i += 2, j++ )
	{
		puwD[j] = pubS[i];
	}
}
static	IMG_VVOID	Bilinear_RBG_TBBoundaryB_SSE(	IMG_UWORD	*puwS,
													IMG_UBYTE	*pubB,
													IMG_LWORD	lwOpX,
													IMG_ULWORD	ulHalf,
													IMG_ULWORD	ulShift,
													IMG_ULWORD	ulCoOdd1,			// 16-bit unsigned integer
													IMG_ULWORD	ulCoOdd2,
													IMG_ULWORD	ulCoEven1,
													IMG_ULWORD	ulCoEven2)
{
	IMG_LWORD	i = 0, j;

	__asm
	{
		mov			ecx, lwOpX
		inc			ecx

		sar			ecx, 4
		jz			sse_over

		sal			ecx, 4
		mov			i, ecx
		sar			ecx, 4

		mov			asm_si, puwS
		mov			asm_di, pubB

		movd		xmm6, ulHalf
		pshufd		xmm6, xmm6, 0			// xmm6[i] = ulHalf

		movd		xmm5, ulShift

		movd		xmm7, ulCoOdd1			// xmm7 Odd1

		movd		xmm4, ulCoOdd2			// mm4 Odd2
		punpcklwd	xmm7, xmm4
		pshufd		xmm7, xmm7, 0			// xmm7[0, 2, 4, 6] = Odd1, mm5[1, 3, 5, 7] = Odd2

		movd		mm4, ulCoEven1			// mm4 Even1

		movd		mm3, ulCoEven2			// mm3 Even2
		punpcklwd	mm4, mm3
		punpckldq	mm4, mm4				// mm4[0, 2, 4, 6] = Even1, mm4[1, 3, 5, 7] = Even2

		movdqa		xmm0, [asm_si]			// xmm0 B[0 ~ 7]
		add			asm_si, 16

		dec			ecx
		jz			last16
		
sse_loop:
		movdqa		xmm1, [asm_si]			// xmm1 B[8 ~ 16]
		add			asm_si, 16

		movdqa		xmm3, xmm0
		psrldq		xmm3, 2
		movdqa		xmm2, xmm1
		pslldq		xmm2, 14
		por			xmm2, xmm3				// xmm2 B[1] ~ B[8]

		movdqa		xmm4, xmm0				// xmm0 and xmm4 B[0] ~ B[7]

		punpcklwd	xmm0, xmm2				// xmm0 B[0], B[1], B[1], B[2], B[2], B[3], B[3], B[4]
		punpckhwd	xmm4, xmm2				// xmm4 B[4], B[5], B[5], B[6], B[6], B[7], B[7], B[8]
		
		movq2dq		xmm3, mm4
		punpcklqdq	xmm3, xmm3				// xmm3 even coefficients

		movdqa		xmm2, xmm4
		
		pmaddwd		xmm4, xmm3				// higher bytes
		paddd		xmm4, xmm6
		psrld		xmm4, xmm5

		pmaddwd		xmm3, xmm0				// lower bytes
		paddd		xmm3, xmm6
		psrld		xmm3, xmm5

		packssdw	xmm3, xmm4
		pslldq		xmm3, 1

		pmaddwd		xmm2, xmm7
		paddd		xmm2, xmm6
		psrld		xmm2, xmm5

		pmaddwd		xmm0, xmm7
		paddd		xmm0, xmm6
		psrld		xmm0, xmm5

		packssdw	xmm0, xmm2

		por			xmm3, xmm0

		movdqa		xmm0, xmm1
		
		movdqu		[asm_di], xmm3
		add			asm_di, 16

		dec			ecx
		jnz			sse_loop

last16:
		movzx		eax, word ptr[asm_si]
		movd		xmm2, eax
		pslldq		xmm2, 14

		movdqa		xmm3, xmm0
		psrldq		xmm3, 2
		por			xmm2, xmm3				// xmm2 B[1 ~ 8]

		movdqa		xmm4, xmm0				// xmm0 and xmm4 B[0] ~ B[7]

		punpcklwd	xmm0, xmm2				// xmm0 B[0], B[1], B[1], B[2], B[2], B[3], B[3], B[4]
		punpckhwd	xmm4, xmm2				// xmm4 B[4], B[5], B[5], B[6], B[6], B[7], B[7], B[8]
		
		movq2dq		xmm3, mm4
		punpcklqdq	xmm3, xmm3				// xmm3 even coefficients

		movdqa		xmm2, xmm4
		
		pmaddwd		xmm4, xmm3				// higher bytes
		paddd		xmm4, xmm6
		psrld		xmm4, xmm5

		pmaddwd		xmm3, xmm0				// lower bytes
		paddd		xmm3, xmm6
		psrld		xmm3, xmm5

		packssdw	xmm3, xmm4
		pslldq		xmm3, 1

		pmaddwd		xmm2, xmm7
		paddd		xmm2, xmm6
		psrld		xmm2, xmm5

		pmaddwd		xmm0, xmm7
		paddd		xmm0, xmm6
		psrld		xmm0, xmm5

		packssdw	xmm0, xmm2

		por			xmm3, xmm0
		movdqu		[asm_di], xmm3

sse_over:
		emms
	}
	for( j = i >> 1; i < lwOpX; i += 2, j++ )
	{
		pubB[i] = (IMG_UBYTE)((puwS[j] * ulCoOdd1 + puwS[j+1] * ulCoOdd2 + ulHalf) >> ulShift);
		pubB[i+1] = (IMG_UBYTE)((puwS[j] * ulCoEven1 + puwS[j+1] * ulCoEven2 + ulHalf) >> ulShift);
	}
}
static	IMG_VVOID	Bilinear_RBG_Sum2Row_R_SSE(	IMG_UBYTE	*pubS1,
												IMG_UBYTE	*pubS2,
												IMG_UWORD	*puwD,
												IMG_LWORD	lwOpX)
{
	IMG_LWORD	i = 0, j;

	__asm
	{
		mov			ecx, lwOpX
		sar			ecx, 4
		jz			sse_over

		sal			ecx, 4
		mov			i, ecx
		sar			ecx, 4

		pcmpeqb		xmm7, xmm7
		pxor		xmm6, xmm6
		punpcklbw	xmm7, xmm6					// xmm7[0, 2, ..., 14] = ff, xmm7[1, 3, 5, ..., 15] = 0

		mov			asm_si, pubS1
		mov			asm_ax, pubS2
		mov			asm_di, puwD

sse_loop:
		movdqu		xmm0, [asm_si]
		add			asm_si, 16

		psrldq		xmm0, 1
		pand		xmm0, xmm7

		movdqu		xmm1, [asm_ax]
		add			asm_ax, 16

		psrldq		xmm1, 1
		pand		xmm1, xmm7

		paddw		xmm0, xmm1
		
		movdqa		[asm_di], xmm0
		add			asm_di, 16

		dec			ecx
		jnz			sse_loop

sse_over:
	}
	for( j = i >> 1, i++; i < lwOpX; i += 2, j++ )
	{
		puwD[j] = pubS1[i] + pubS2[i];
	}
}
IMG_VVOID	Bilinear_GRB_G_TopLine(	IMG_UBYTE	*pubS1,
									IMG_UBYTE	*pubS2,
									IMG_UBYTE	*pubG,
									IMG_ULWORD	ulCoG1,				// 16-bit unsigned integer
									IMG_ULWORD	ulCoG2,
									IMG_ULWORD	ulCoG3,
									IMG_ULWORD	ulShift,
									IMG_ULWORD	ulHalf,
									IMG_LWORD	lwOpX)
{
	IMG_LWORD	i = 2;

	__asm
	{
		mov			ecx, lwOpX
		add			ecx, 2
		sar			ecx, 3
		je			sse_over

		sal			ecx, 3
		mov			i, ecx
		sar			ecx, 3

		xor			edx, edx					// label

		mov			asm_si, pubS1
		mov			asm_ax, pubS2
		mov			asm_di, pubG

		pcmpeqb		xmm7, xmm7
		pxor		xmm5, xmm5
		punpcklbw	xmm7, xmm5					// xmm7[0,2,4] = 0xFF, xmm7[1,3,5,7] = 0

		movd		mm0, ulCoG1
		punpcklwd	mm0, mm0
		punpckldq	mm0, mm0					// mm0[0~7] ulCoG1
		movd		mm1, ulCoG2
		movd		mm2, ulCoG3
		punpcklwd	mm1, mm2
		punpckldq	mm1, mm1					// mm1[0,2] = ulCoG2, mm1[1,3] = ulCoG3

		movq		xmm2, qword ptr [asm_si]	// first line G[0~3]
		add			asm_si, 8
		pand		xmm2, xmm7

		movq		xmm3, qword ptr [asm_ax]	// second line G[0~3]
		add			asm_ax, 8
		psrldq		xmm3, 1
		pand		xmm3, xmm7

		dec			ecx
		je			only_8

sse_loop:
		movq		xmm4, qword ptr [asm_si]	// first line G[4~7]
		add			asm_si, 8
		pand		xmm4, xmm7

		movdqa		xmm5, xmm4
		pslldq		xmm5, 6
		movdqa		xmm6, xmm2
		psrldq		xmm2, 2
		por			xmm5, xmm2					// G1[1~4]

		movdqa		xmm2, xmm4
		
		movdqa		xmm0, xmm6					// xmm0 G1[0~3], Even output
		punpcklwd	xmm6, xmm5					// xmm6 G1[0] G1[1] G1[1] G1[2] G1[2] G1[3] G1[3] G1[4]

		movq		xmm4, qword ptr [asm_ax]	// second line G[4~7]
		add			asm_ax, 8
		psrldq		xmm4, 1
		pand		xmm4, xmm7

		movdqa		xmm5, xmm4
		pslldq		xmm5, 6
		movdqa		xmm1, xmm3
		psrldq		xmm3, 2
		por			xmm5, xmm3					// xmm5 G2[1~4]

		punpcklwd	xmm1, xmm5					// xmm1 G2[0] G2[1] G2[1] G2[2] G2[2] G2[3] G2[3] G2[4]
		movdqa		xmm3, xmm4

main_computation:
		movq2dq		xmm4, mm0
		punpcklqdq	xmm4, xmm4
		pmaddwd		xmm4, xmm6

		movq2dq		xmm5, mm1
		punpcklqdq	xmm5, xmm5
		pmaddwd		xmm5, xmm1
		paddd		xmm4, xmm5					// xmm4 Odd output

		movd		xmm5, ulHalf
		pshufd		xmm5, xmm5, 0
		paddd		xmm4, xmm5

		movd		xmm5, ulShift
		psrld		xmm4, xmm5
		packssdw	xmm4, xmm4
		pslldq		xmm4, 1
		por			xmm4, xmm0

		movq		qword ptr [asm_di], xmm4
		add			asm_di, 8

		dec			ecx
		jnz			sse_loop

		test		edx, edx
		jnz			sse_over

only_8:
		movdqa		xmm0, xmm2
		movdqa		xmm6, xmm2
		psrldq		xmm2, 2
		punpcklwd	xmm6, xmm2

		movdqa		xmm1, xmm3
		psrldq		xmm3, 2
		punpcklwd	xmm1, xmm3

		inc			ecx
		inc			edx
		jmp			main_computation

sse_over:
		emms
	}
	for( i -= 2; i < lwOpX; i += 2 )
	{
		pubG[i] = pubS1[i];
		pubG[i+1] = (IMG_UBYTE)((	ulCoG1*pubS1[i] + ulCoG1*pubS1[i+2] +
									ulCoG2*pubS2[i+1] + ulCoG3*pubS2[i+3] + ulHalf) >> ulShift);
	}
	pubG[i] = pubS1[i];
}
static	IMG_VVOID	BilinearRBG_EvenRowR_SSE(	IMG_UBYTE	*pubS,
												IMG_UBYTE	*pubR,
												IMG_LWORD	lwOpX)
{
	IMG_LWORD	i = 0;

	__asm
	{
		mov			ecx, lwOpX
		add			ecx, 2
		
		sar			ecx, 4
		jz			sse_over

		sal			ecx, 4
		mov			i, ecx
		sar			ecx, 4

		pxor		xmm6, xmm6
		pcmpeqb		xmm7, xmm7
		punpcklbw	xmm7, xmm6				// xmm7[0, 2 ...] = ff, xmm7[1, 3 ...] = 0

		mov			asm_si, pubS
		mov			asm_di, pubR

		movdqu		xmm0, [asm_si]			// xmm0[0, 2 ...] = R, xmm0[1, 3 ...] = G
		add			asm_si, 16

		pand		xmm0, xmm7				// xmm0[0, 2 ...] = R, xmm0[1, 3 ...] = 0
		dec			ecx
		jz			last16

sse_loop:
		movdqu		xmm1, [asm_si]			// xmm1[0, 2 ...] = R, xmm0[1, 3 ...] = G
		add			asm_si, 16

		movdqa		xmm2, xmm0
		psrldq		xmm2, 2

		pand		xmm1, xmm7				// xmm1[0, 2 ...] = R, xmm0[1, 3 ...] = 0

		movdqa		xmm3, xmm1
		pslldq		xmm3, 14
		por			xmm2, xmm3
		pavgb		xmm2, xmm0				// average of R[i] and R[i+2]

		pslldq		xmm2, 1
		por			xmm2, xmm0
		movdqu		[asm_di], xmm2
		add			asm_di, 16

		movdqa		xmm0, xmm1
		dec			ecx
		jnz			sse_loop

last16:
		movdqa		xmm2, xmm0
		psrldq		xmm2, 2

		pavgb		xmm2, xmm0
		pslldq		xmm2, 1
		por			xmm2, xmm0
		movdqu		[asm_di], xmm2

sse_over:
	}
	if( i != 0 && i <= lwOpX )
	{
		pubR[i-1] = ((pubS[i-2] + pubS[i]) + 1) >> 1;			// ">>1" = "/2" and "+1" for rounding
	}
	for( ; i < lwOpX; i += 2 )
	{
		pubR[i] = pubS[i];
		pubR[i+1] = ((pubS[i] + pubS[i+2]) + 1) >> 1;			// ">>1" = "/2" and "+1" for rounding
	}
	pubR[lwOpX+1] = pubR[lwOpX] = pubS[lwOpX];
}
IMG_VVOID	Bilinear_GRB_G_OddLine(	IMG_UBYTE	*pubS1,
									IMG_UBYTE	*pubS2,
									IMG_UBYTE	*pubS3,
									IMG_UBYTE	*pubS4,
									IMG_UBYTE	*pubG,
									IMG_ULWORD	ulCoOdd1,
									IMG_ULWORD	ulCoOdd2,
									IMG_ULWORD	ulCoOdd3,
									IMG_ULWORD	ulCoOdd4,
									IMG_ULWORD	ulCoEven1,
									IMG_ULWORD	ulCoEven2,
									IMG_ULWORD	ulCoEven3,
									IMG_ULWORD	ulCoEven4,
									IMG_ULWORD	ulCoEven5,
									IMG_ULWORD	ulShift,
									IMG_ULWORD	ulHalf,
									IMG_LWORD	lwOpX)
{
	IMG_LWORD	i = 2, lwLabel = 0;

	__asm
	{
		push		asm_bx

		mov			ecx, lwOpX
		inc			ecx
		sar			ecx, 3
		je			sse_over

		sal			ecx, 3
		mov			i, ecx
		sar			ecx, 3

		mov			asm_si, pubS1
		mov			asm_ax, pubS2
		mov			asm_bx, pubS3
		mov			asm_dx, pubS4
		mov			asm_di, pubG

		pcmpeqb		mm7, mm7
		pxor		mm6, mm6
		punpcklbw	mm7, mm6					// mm7[0,2,4,6] = 0x0ff, mm7[1,3,5,7] = 0

		movd		mm0, ulCoOdd1
		punpcklwd	mm0, mm0
		punpckldq	mm0, mm0					// mm0[0~3] = ulCoOdd1

		movd		mm1, ulCoOdd2
		movd		mm2, ulCoOdd3
		punpcklwd	mm1, mm2
		punpckldq	mm1, mm1					// mm1[0,2] = ulCoOdd2, mm1[1,3] = ulCoOdd3

		movd		mm3, ulCoOdd4
		punpcklwd	mm2, mm3
		punpckldq	mm2, mm2					// mm2[0,2] = ulCoOdd3, mm2[1,3] = ulCoOdd4

		movd		mm3, ulCoEven1
		punpckldq	mm3, mm3
		pslld		mm3, 16						// mm3[0,2] = 0, mm3[1,3] = ulCoEven1

		movd		mm4, ulCoEven2
		movd		mm5, ulCoEven3
		punpcklwd	mm4, mm5
		punpckldq	mm4, mm4					// mm4[0,2] = ulCoEven2, mm4[1,3] = ulCoEven3

		movd		mm5, ulCoEven4
		movd		mm6, ulCoEven5
		punpcklwd	mm5, mm6
		punpckldq	mm5, mm5					// mm5[0,2] = ulCoEven4, mm6[1,3] = ulCoEven5

		movq2dq		xmm7, mm7

		movq		xmm0, qword ptr [asm_si]	// first line G1[0~3]
		add			asm_si, 8
		pand		xmm0, xmm7

		movq		xmm1, qword ptr [asm_bx]	// third line G3[0~3]
		add			asm_bx, 8
		pand		xmm1, xmm7
		paddw		xmm0, xmm1					// (G1+G3)[0~3]

		movq		xmm1, qword ptr [asm_ax]	// second line G2[0~3]
		add			asm_ax, 8
		psrldq		xmm1, 1
		pand		xmm1, xmm7

		movq		xmm2, qword ptr [asm_dx]	// fourth line G4[0~3]
		add			asm_dx, 8
		psrldq		xmm2, 1
		pand		xmm2, xmm7

		dec			ecx
		je			only_8

sse_loop:
		movq2dq		xmm7, mm7

		movq		xmm3, qword ptr [asm_si]	// first line G1[4~7]
		add			asm_si, 8
		pand		xmm3, xmm7

		movq		xmm4, qword ptr [asm_bx]	// third line G3[4~7]
		add			asm_bx, 8
		pand		xmm4, xmm7
		paddw		xmm3, xmm4					// (G1+G3)[4~7]

		movdqa		xmm5, xmm3
		pslldq		xmm5, 6
		movdqa		xmm6, xmm0
		psrldq		xmm0, 2
		por			xmm5, xmm0					// (G1+G3)[1~4]
		punpcklwd	xmm6, xmm5					// (G1+G3)[0] (G1+G3)[1] (G1+G3)[1] (G1+G3)[2] (G1+G3)[2] (G1+G3)[3] (G1+G3)[3] (G1+G3)[4]

		movdqa		xmm0, xmm3

		movq		xmm3, qword ptr [asm_ax]	// second line G2[4~7]
		add			asm_ax, 8
		psrldq		xmm3, 1
		pand		xmm3, xmm7

		movdqa		xmm4, xmm3
		pslldq		xmm4, 6
		movdqa		xmm5, xmm1
		psrldq		xmm1, 2
		por			xmm4, xmm1					// G2[1~4]
		punpcklwd	xmm5, xmm4					// G2[0] G2[1] G2[1] G2[2] G2[2] G2[3] G2[3] G2[4]

		movdqa		xmm1, xmm3

		movq		xmm4, qword ptr [asm_dx]	// fourth line G4[4~7]
		add			asm_dx, 8
		psrldq		xmm4, 1
		pand		xmm4, xmm7

		movdqa		xmm3, xmm4
		pslldq		xmm3, 6
		movdqa		xmm7, xmm2
		psrldq		xmm2, 2
		por			xmm3, xmm2					// G4[1~4]
		punpcklwd	xmm7, xmm3					// G4[0] G4[1] G4[1] G4[2] G4[2] G4[3] G4[3] G4[4]

		movdqa		xmm2, xmm4

main_computation:
		movq2dq		xmm3, mm1
		punpcklqdq	xmm3, xmm3
		pmaddwd		xmm3, xmm5

		movq2dq		xmm4, mm2
		punpcklqdq	xmm4, xmm4
		pmaddwd		xmm4, xmm7
		paddd		xmm3, xmm4

		movq2dq		xmm4, mm0
		punpcklqdq	xmm4, xmm4
		pmaddwd		xmm4, xmm6
		paddd		xmm3, xmm4					// xmm3 Odd output

		movq2dq		xmm4, mm3
		punpcklqdq	xmm4, xmm4
		pmaddwd		xmm4, xmm6

		movq2dq		xmm6, mm4
		punpcklqdq	xmm6, xmm6
		pmaddwd		xmm6, xmm5
		paddd		xmm4, xmm6

		movd		xmm6, ulHalf
		pshufd		xmm6, xmm6, 0

		movq2dq		xmm5, mm5
		punpcklqdq	xmm5, xmm5
		pmaddwd		xmm5, xmm7
		paddd		xmm4, xmm5					// xmm4 Even output

		movd		xmm5, ulShift

		paddd		xmm3, xmm6
		paddd		xmm4, xmm6
		
		psrld		xmm3, xmm5
		psrld		xmm4, xmm5
		pslldq		xmm4, 2
		por			xmm3, xmm4

		packuswb	xmm3, xmm3
		movq		qword ptr [asm_di], xmm3
		add			asm_di, 8

		dec			ecx
		jnz			sse_loop

		mov			eax, lwLabel
		test		eax, eax
		jnz			sse_over

only_8:
		movdqa		xmm6, xmm0
		psrldq		xmm0, 2
		punpcklwd	xmm6, xmm0			// (G1+G3)[0] (G1+G3)[1] (G1+G3)[1] (G1+G3)[2] (G1+G3)[2] (G1+G3)[3] (G1+G3)[3] 0

		movdqa		xmm5, xmm1
		psrldq		xmm1, 2
		punpcklwd	xmm5, xmm1			// G2[0] G2[1] G2[1] G2[2] G2[2] G2[3] G2[3] 0

		movdqa		xmm7, xmm2
		psrldq		xmm2, 2
		punpcklwd	xmm7, xmm2			// G4[0] G4[1] G4[1] G4[2] G4[2] G4[3] G4[3] 0

		inc			ecx
		inc			lwLabel
		jmp			main_computation

sse_over:
		pop			asm_bx
		emms
	}
	for( i -= 2; i < lwOpX; i += 2 )
	{
		pubG[i] = (IMG_UBYTE)((	ulCoOdd1*pubS1[i] + ulCoOdd1*pubS1[i+2] +
								ulCoOdd2*pubS2[i+1] + ulCoOdd3*pubS2[i+3] +
								ulCoOdd1*pubS3[i] + ulCoOdd1*pubS3[i+2] +
								ulCoOdd3*pubS4[i+1] + ulCoOdd4*pubS4[i+3] + ulHalf) >> ulShift);
		pubG[i+1] = (IMG_UBYTE)((	ulCoEven1*pubS1[i+2] + ulCoEven2*pubS2[i+1] +
									ulCoEven3*pubS2[i+3] + ulCoEven1*pubS3[i+2] +
									ulCoEven4*pubS4[i+1] + ulCoEven5*pubS4[i+3] + ulHalf) >> ulShift);
	}
}

IMG_VVOID	Bilinear_GRB_G_EvenLine(IMG_UBYTE	*pubS2,
									IMG_UBYTE	*pubS3,
									IMG_UBYTE	*pubS4,
									IMG_UBYTE	*pubG,
									IMG_ULWORD	ulCoOdd1,
									IMG_ULWORD	ulCoOdd2,
									IMG_ULWORD	ulCoOdd3,
									IMG_ULWORD	ulCoOdd4,
									IMG_ULWORD	ulCoOdd5,
									IMG_ULWORD	ulShift,
									IMG_ULWORD	ulHalf,
									IMG_LWORD	lwOpX)
{
	IMG_LWORD	i = 2;

	__asm
	{
		push		asm_bx

		mov			ecx, lwOpX
		add			ecx, 2
		sar			ecx, 3
		je			sse_over

		sal			ecx, 3
		mov			i, ecx
		sar			ecx, 3

		xor			edx, edx					// label

		mov			asm_si, pubS2
		mov			asm_ax, pubS3
		mov			asm_bx, pubS4
		mov			asm_di, pubG

		pcmpeqb		mm7, mm7
		pxor		mm6, mm6
		punpcklbw	mm7, mm6					// mm7[0,2,4,6] = 0x0ff, xmm7[1,3,5,7] = 0

		movd		mm0, ulCoOdd1
		movd		mm1, ulCoOdd2
		punpcklwd	mm0, mm1
		punpckldq	mm0, mm0					// mm0[0,2] = ulCoOdd1, mm0[1,3] = ulCoOdd2

		movd		mm1, ulCoOdd3
		punpcklwd	mm1, mm1
		punpckldq	mm1, mm1					// mm1[0~3] = ulCoOdd3

		movd		mm2, ulCoOdd4
		movd		mm3, ulCoOdd5
		punpcklwd	mm2, mm3
		punpckldq	mm2, mm2					// mm2[0,2] = ulCoOdd4, mm2[1,3] = ulCoOdd5

		movq2dq		xmm7, mm7

		movq		xmm0, qword ptr [asm_si]	// second line G2[0~3]
		add			asm_si, 8
		psrldq		xmm0, 1
		pand		xmm0, xmm7

		movq		xmm1, qword ptr [asm_ax]	// third line G3[0~3]
		add			asm_ax, 8
		pand		xmm1, xmm7

		movq		xmm2, qword ptr [asm_bx]	// fourth line G4[0~3]
		add			asm_bx, 8
		psrldq		xmm2, 1
		pand		xmm2, xmm7

		dec			ecx
		je			only_8

sse_loop:
		movq2dq		xmm7, mm7

		movq		xmm3, qword ptr [asm_si]	// second line G2[4~7]
		add			asm_si, 8
		psrldq		xmm3, 1
		pand		xmm3, xmm7

		movdqa		xmm4, xmm3
		pslldq		xmm4, 6
		movdqa		xmm6, xmm0
		psrldq		xmm0, 2
		por			xmm4, xmm0					// xmm4 G2[1~4]
		punpcklwd	xmm6, xmm4					// xmm6 G2[0] G2[1] G2[1] G2[2] G2[2] G2[3] G2[3] G2[4]

		movdqa		xmm0, xmm3

		movq		xmm3, qword ptr [asm_ax]	// third line G3[4~7]
		add			asm_ax, 8
		pand		xmm3, xmm7

		movdqa		xmm4, xmm3
		pslldq		xmm4, 6
		movdqa		xmm5, xmm1
		psrldq		xmm1, 2
		por			xmm4, xmm1					// xmm4 G3[1~4]
		movdq2q		mm6, xmm5					// mm6 G3[0~3]
		punpcklwd	xmm5, xmm4					// xmm5 G3[0] G3[1] G3[1] G3[2] G3[2] G3[3] G3[3] G3[4]

		movdqa		xmm1, xmm3

		movq		xmm4, qword ptr [asm_bx]	// fourth line G4[4~7]
		add			asm_bx, 8
		psrldq		xmm4, 1
		pand		xmm4, xmm7

		movdqa		xmm3, xmm4
		pslldq		xmm3, 6
		movdqa		xmm7, xmm2
		psrldq		xmm2, 2
		por			xmm3, xmm2					// G4[1~4]
		punpcklwd	xmm7, xmm3					// G4[0] G4[1] G4[1] G4[2] G4[2] G4[3] G4[3] G4[4]

		movdqa		xmm2, xmm4

main_computation:
		movq2dq		xmm3, mm0
		punpcklqdq	xmm3, xmm3
		pmaddwd		xmm6, xmm3

		movq2dq		xmm4, mm1
		punpcklqdq	xmm4, xmm4
		pmaddwd		xmm4, xmm5

		movd		xmm3, ulHalf
		pshufd		xmm3, xmm3, 0

		paddd		xmm6, xmm4
		paddd		xmm6, xmm3
		
		movq2dq		xmm4, mm2
		punpcklqdq	xmm4, xmm4
		pmaddwd		xmm4, xmm7

		movd		xmm3, ulShift
		paddd		xmm6, xmm4
		psrld		xmm6, xmm3

		movq2dq		xmm7, mm6
		packssdw	xmm6, xmm6
		pslldq		xmm6, 1
		por			xmm6, xmm7

		movq		qword ptr [asm_di], xmm6
		add			asm_di, 8

		dec			ecx
		jnz			sse_loop

		test		edx, edx
		jnz			sse_over

only_8:
		movdqa		xmm6, xmm0
		psrldq		xmm0, 2
		punpcklwd	xmm6, xmm0					// xmm6 G2[0] G2[1] G2[1] G2[2] G2[2] G2[3] G2[3] 0

		movdq2q		mm6, xmm1
		movdqa		xmm5, xmm1
		psrldq		xmm1, 2
		punpcklwd	xmm5, xmm1					// xmm5 G3[0] G3[1] G3[1] G3[2] G3[2] G3[3] G3[3] 0

		movdqa		xmm7, xmm2
		psrldq		xmm2, 2
		punpcklwd	xmm7, xmm2					// xmm7 G4[0] G4[1] G4[1] G4[2] G4[2] G4[3] G4[3] 0

		inc			ecx
		inc			edx
		jmp			main_computation

sse_over:
		pop			asm_bx
		emms
	}
	for( i -= 2; i < lwOpX; i += 2 )
	{
		pubG[i] = pubS3[i];
		pubG[i+1] = (IMG_UBYTE)((	ulCoOdd1*pubS2[i+1] + ulCoOdd2*pubS2[i+3] +
									ulCoOdd3*pubS3[i] + ulCoOdd3*pubS3[i+2] +
									ulCoOdd4*pubS4[i+1] + ulCoOdd5*pubS4[i+3] + ulHalf) >> ulShift);
	}
	pubG[i] = pubS3[i];
}
IMG_VVOID	Bilinear_GRB_G_BottomLine(	IMG_UBYTE	*pubS1,
										IMG_UBYTE	*pubS2,
										IMG_UBYTE	*pubG,
										IMG_ULWORD	ulCoOdd1,				// 16-bit unsigned integer
										IMG_ULWORD	ulCoOdd2,
										IMG_ULWORD	ulCoOdd3,
										IMG_ULWORD	ulCoEven1,
										IMG_ULWORD	ulCoEven2,
										IMG_ULWORD	ulCoEven3,
										IMG_ULWORD	ulShift,
										IMG_ULWORD	ulHalf,
										IMG_LWORD	lwOpX)
{
	IMG_LWORD	i = 2;

	__asm
	{
		mov			ecx, lwOpX
		inc			ecx
		sar			ecx, 3
		je			sse_over

		sal			ecx, 3
		mov			i, ecx
		sar			ecx, 3

		mov			asm_si, pubS1
		mov			asm_dx, pubS2
		mov			asm_di, pubG

		xor			eax, eax						// label

		pcmpeqb		xmm7, xmm7
		pxor		xmm5, xmm5
		punpcklbw	xmm7, xmm5

		movd		mm0, ulCoOdd1
		punpcklwd	mm0, mm0
		punpckldq	mm0, mm0						// mm0[0,1,2,3] = ulCoOdd1

		movd		mm1, ulCoOdd2
		movd		mm2, ulCoOdd3
		punpcklwd	mm1, mm2
		punpckldq	mm1, mm1						// mm1[0,2] = ulCoOdd2, mm1[1,3] = ulCoOdd3

		movd		mm2, ulCoEven1
		punpckldq	mm2, mm2
		pslld		mm2, 16							// mm2[0,2] = 0, mm2[1,3] = ulCoEven1

		movd		mm3, ulCoEven2
		movd		mm4, ulCoEven3
		punpcklwd	mm3, mm4
		punpckldq	mm3, mm3						// mm3[0,2] = ulCoEven2, mm3[1,3] = ulCoEven3

		movq		xmm0, qword ptr [asm_si]		// first line G1[0~3]
		add			asm_si, 8
		pand		xmm0, xmm7

		movq		xmm1, qword ptr [asm_dx]		// second line G2[0~3]
		add			asm_dx, 8
		psrldq		xmm1, 1
		pand		xmm1, xmm7

		dec			ecx
		je			only_8

sse_loop:
		movq		xmm2, qword ptr [asm_si]		// first line G1[4~7]
		add			asm_si, 8
		pand		xmm2, xmm7

		movdqa		xmm3, xmm2
		pslldq		xmm3, 6
		movdqa		xmm4, xmm0
        psrldq		xmm0, 2
		por			xmm3, xmm0						// xmm3 G1[1~4]

		punpcklwd	xmm4, xmm3						// xmm4 G1[0] G1[1] G1[1] G1[2] G1[2] G1[3] G1[3] G1[4]
		movdqa		xmm0, xmm2

		movq		xmm3, qword ptr [asm_dx]		// second line G2[4~7]
		add			asm_dx, 8
		psrldq		xmm3, 1
		pand		xmm3, xmm7

		movdqa		xmm2, xmm3
		pslldq		xmm2, 6
		movdqa		xmm5, xmm1
		psrldq		xmm1, 2
		por			xmm2, xmm1						// xmm2 G2[1~4]

		punpcklwd	xmm5, xmm2						// xmm5 G2[0] G2[1] G2[1] G2[2] G2[2] G2[3] G2[3] G2[4]
		movdqa		xmm1, xmm3

main_computation:
		movq2dq		xmm2, mm0
		punpcklqdq	xmm2, xmm2
		pmaddwd		xmm2, xmm4

		movq2dq		xmm3, mm1
		punpcklqdq	xmm3, xmm3
		pmaddwd		xmm3, xmm5

		paddd		xmm2, xmm3						// xmm2 Odd output

		movq2dq		xmm6, mm2
		punpcklqdq	xmm6, xmm6
		pmaddwd		xmm6, xmm4

		movd		xmm4, ulHalf
		pshufd		xmm4, xmm4, 0

		movq2dq		xmm3, mm3
		punpcklqdq	xmm3, xmm3
		pmaddwd		xmm3, xmm5

        paddd		xmm2, xmm4
		paddd		xmm6, xmm3						// xmm6 Even output
		
		movd		xmm3, ulShift
		paddd		xmm6, xmm4
		psrld		xmm2, xmm3
		psrld		xmm6, xmm3

		pslldq		xmm6, 2
		por			xmm2, xmm6
		packuswb	xmm2, xmm2

		movq		qword ptr [asm_di], xmm2
		add			asm_di, 8

		dec			ecx
		jnz			sse_loop

		test		eax, eax
		jnz			sse_over

only_8:
		movdqa		xmm4, xmm0
		psrldq		xmm0, 2
		punpcklwd	xmm4, xmm0			// xmm4 G1[0] G1[1] G1[1] G1[2] G1[2] G1[3] 0

		movdqa		xmm5, xmm1
		psrldq		xmm1, 2
		punpcklwd	xmm5, xmm1			// xmm5 G2[0] G2[1] G2[1] G2[2] G2[2] G2[3] 0

		inc			ecx
		inc			eax
		jmp			main_computation

sse_over:
		emms
	}
	for( i -= 2; i < lwOpX; i += 2 )
	{
		pubG[i] = (IMG_UBYTE)((	ulCoOdd1*pubS1[i] + ulCoOdd1*pubS1[i+2] +
								ulCoOdd2*pubS2[i+1] + ulCoOdd3*pubS2[i+3] + ulHalf) >> ulShift);
		pubG[i+1] = (IMG_UBYTE)((ulCoEven1*pubS1[i+2] + ulCoEven2*pubS2[i+1] + ulCoEven3*pubS2[i+3] + ulHalf) >> ulShift);
	}
}
static	IMG_VVOID	Bilinear_GRB_InnerB_SSE(	IMG_UBYTE	*pubS1,
												IMG_UBYTE	*pubS2,
												IMG_UBYTE	*pubB,
												IMG_LWORD	lwOpX,
												IMG_ULWORD	ulHalf,
												IMG_ULWORD	ulShift,
												IMG_ULWORD	ulCoOdd1,				// 16-bit unsigned integer
												IMG_ULWORD	ulCoOdd2,
												IMG_ULWORD	ulCoEven1,
												IMG_ULWORD	ulCoEven2)
{
	IMG_LWORD	i = 0;

	__asm
	{
		mov			ecx, lwOpX
		inc			ecx

		sar			ecx, 3
		jz			sse_over

		sal			ecx, 3
		mov			i, ecx
		sar			ecx, 3

		mov			asm_si, pubS1
		mov			asm_dx, pubS2
		mov			asm_di, pubB

		pcmpeqb		xmm7, xmm7
		pxor		xmm6, xmm6
		punpcklbw	xmm7, xmm6				// xmm7[0, 2 ...] = ff, xmm7[1, 3 ...] = 0

		movd		xmm6, ulHalf
		pshufd		xmm6, xmm6, 0			// xmm6[i] = ulHalf

		movd		mm0, ulShift

		movd		mm5, ulCoOdd1			// mm5 Odd1

		movd		mm4, ulCoOdd2			// mm4 Odd2
		punpcklwd	mm5, mm4
		punpckldq	mm5, mm5				// mm5[0, 2, 4, 6] = Odd1, mm5[1, 3, 5, 7] = Odd2

		movd		mm4, ulCoEven1			// mm4 Even1

		movd		mm3, ulCoEven2			// mm3 Even2
		punpcklwd	mm4, mm3
		punpckldq	mm4, mm4				// mm4[0, 2, 4, 6] = Even1, mm4[1, 3, 5, 7] = Even2

		movq		xmm0, qword ptr[asm_si]	// xmm0[0, 2, 4, 6] = B, xmm0[1, 3, 5, 7] = G
		add			asm_si, 8

		pand		xmm0, xmm7				// xmm0[0, 2, 4, 6] = B, xmm0[1, 3, 5, 7] = 0

		movq		xmm1, qword ptr[asm_dx]	// xmm1[0, 2, 4, 6] = B, xmm1[1, 3, 5, 7] = G
		add			asm_dx, 8

		pand		xmm1, xmm7				// xmm1[0, 2, 4, 6] = B, xmm1[1, 3, 5, 7] = 0

		dec			ecx
		jz			last16
		
sse_loop:
		movq		xmm2, qword ptr[asm_si]	// xmm2[0, 2, 4, 6] = B, xmm2[1, 3, 5, 7] = G
		add			asm_si, 8
		pand		xmm2, xmm7				// xmm2[0, 2, 4, 6] = B, xmm2[1, 3, 5, 7] = 0

		movdqa		xmm3, xmm0
		psrldq		xmm3, 2
		movdqa		xmm4, xmm2
		pslldq		xmm4, 6
		por			xmm4, xmm3				// xmm4 B[01] ~ B[04]

		punpcklwd	xmm0, xmm1				// xmm0 B[00], B[10], B[01], B[11], B[02], B[12], B[03], B[13]

		movq		xmm3, qword ptr[asm_dx]	// xmm3[0, 2, 4, 6] = B, xmm3[1, 3, 5, 7] = G
		add			asm_dx, 8
		pand		xmm3, xmm7				// xmm3[0, 2, 4, 6] = B, xmm3[1, 3, 5, 7] = 0

		psrldq		xmm1, 2
		movdqa		xmm5, xmm3
		pslldq		xmm5, 6
		por			xmm1, xmm5				// xmm1 B[11] ~ B[14]

		punpcklwd	xmm4, xmm1				// xmm4 B[01], B[11], B[02], B[12], B[03], B[13], B[04], B[14]

		movq2dq		xmm5, mm4				// xmm5 Even coefficients
		punpcklqdq	xmm5, xmm5
		pmaddwd		xmm5, xmm0
		
		movq2dq		xmm1, mm0
		paddd		xmm5, xmm6
		psrld		xmm5, xmm1

		paddw		xmm4, xmm0
		movq2dq		xmm0, mm5				// xmm0 Odd coefficients
		punpcklqdq	xmm0, xmm0
		pmaddwd		xmm4, xmm0

		packssdw	xmm5, xmm5
		paddd		xmm4, xmm6
		movdqa		xmm0, xmm2
		psrld		xmm4, xmm1

		movdqa		xmm1, xmm3
        packssdw	xmm4, xmm4
		pslldq		xmm4, 1
		por			xmm4, xmm5

		movq		qword ptr[asm_di], xmm4
		add			asm_di, 8

		dec			ecx
		jnz			sse_loop

last16:
		movdqa		xmm2, xmm0
		psrldq		xmm2, 2
		punpcklwd	xmm0, xmm1

		movdqa		xmm3, xmm1
		psrldq		xmm3, 2

		punpcklwd	xmm2, xmm3
		paddw		xmm2, xmm0

		movq2dq		xmm4, mm4				// xmm4 Even coefficients
		punpcklqdq	xmm4, xmm4
		pmaddwd		xmm0, xmm4
		
		movq2dq		xmm1, mm0
		paddd		xmm0, xmm6
		psrld		xmm0, xmm1

		movq2dq		xmm5, mm5				// xmm5 Odd coefficients
		punpcklqdq	xmm5, xmm5
		pmaddwd		xmm2, xmm5
		
		packssdw	xmm0, xmm0
		paddd		xmm2, xmm6
		psrld		xmm2, xmm1
		packssdw	xmm2, xmm2
		pslldq		xmm2, 1

		por			xmm0, xmm2
		movq		qword ptr[asm_di], xmm0

sse_over:
		emms
	}
	if( i != 0 && i <= lwOpX )
	{
		pubB[i-1] = (IMG_UBYTE)((	(pubS1[i-2] + pubS1[i]) * ulCoOdd1 +
									(pubS2[i-2] + pubS2[i]) * ulCoOdd2 + ulHalf) >> ulShift);
	}
	for( ; i < lwOpX; i += 2 )
	{
		pubB[i] = (IMG_UBYTE)((	pubS1[i] * ulCoEven1 + pubS2[i] * ulCoEven2 + ulHalf) >> ulShift);
		pubB[i+1] = (IMG_UBYTE)((	(pubS1[i] + pubS1[i+2]) * ulCoOdd1 +
									(pubS2[i] + pubS2[i+2]) * ulCoOdd2 + ulHalf) >> ulShift);
	}
	pubB[lwOpX+1] = pubB[lwOpX] = (IMG_UBYTE)((pubS1[lwOpX] * ulCoEven1 + pubS2[lwOpX] * ulCoEven2 + ulHalf) >> ulShift);
}
static	IMG_WORD	BilinearGRB_SSE(IMG_UBBUF	const	*pubbS,
									IMG_COORD	const	*pcoS,
									IMG_UBBUF			*pubbR,
									IMG_UBBUF			*pubbG,
									IMG_UBBUF			*pubbB,
									IMG_COORD	const	*pcoD,
									IMG_SIZE	const	*pszOp,
									IMG_UBYTE	const	ubSkipppingMode)
{
	IMG_WORD	wStatus;
	IMG_UBYTE	*pubS1, *pubS2, *pubS3, *pubS4, *pubR, *pubG, *pubB;
	IMG_UWORD	*puwTS = NULL;
	IMG_ULWORD	ulS2Linestep = pubbS->linestep << 1;		// "<<1" = "*2"
	IMG_LWORD	lwOpY = pszOp->y-2, lwOpX = pszOp->x-2;
	IMG_REAL	rDis_sm, rDis_sm_sub_1, rDis_sm_add_1, rDis_sm_mul2_sub_1, rDis_1, rDis_0, rT;
	IMG_REAL	rTmp, rTmp1, rTmp2, rTmp3, rTmp4, rTmp5, rFloatToFixedPoint = 16384;
	IMG_ULWORD	ulHalf = 8192, ulShift = 14;
	IMG_ULWORD	ulCoEvenRowOddR1, ulCoEvenRowOddR2, ulCoEvenRowEvenR1, ulCoEvenRowEvenR2;
	IMG_ULWORD	ulCoOddRowOddR1, ulCoOddRowOddR2, ulCoOddRowEvenR1, ulCoOddRowEvenR2;
	IMG_ULWORD	ulCoOddRowOddB1, ulCoOddRowOddB2, ulCoOddRowEvenB1, ulCoOddRowEvenB2;
	IMG_ULWORD	ulCoEvenRowOddB1, ulCoEvenRowOddB2, ulCoEvenRowEvenB1, ulCoEvenRowEvenB2;
	IMG_ULWORD	ulCoRTLBCornerG1, ulCoRTLBCornerG2, ulCoRBCornerG1, ulCoRBCornerG2, ulCoTLBoundaryG1, ulCoTLBoundaryG2, ulCoTLBoundaryG3;
	IMG_ULWORD	ulCoRBBoundaryOddG1, ulCoRBBoundaryOddG2, ulCoRBBoundaryOddG3, ulCoRBBoundaryEvenG1, ulCoRBBoundaryEvenG2, ulCoRBBoundaryEvenG3;
	IMG_ULWORD	ulCoOddRowOddG1, ulCoOddRowOddG2, ulCoOddRowOddG3, ulCoOddRowOddG4, ulCoOddRowEvenG1, ulCoOddRowEvenG2, ulCoOddRowEvenG3, ulCoOddRowEvenG4, ulCoOddRowEvenG5;
	IMG_ULWORD	ulCoEvenRowOddG1, ulCoEvenRowOddG2, ulCoEvenRowOddG3, ulCoEvenRowOddG4, ulCoEvenRowOddG5;
	IMG_LWORD	j;

	/*wStatus = MEM_PushAllHeapStatus();
	if( wStatus != OK )					return wStatus;*/

	/*puwTS = (IMG_UWORD*)MEM_Malloc_align((pszOp->x >> 1), SYS_BANK1_16, __FILE__, __LINE__, 16);*/
	puwTS =(IMG_UWORD*) malloc(sizeof(IMG_UWORD)*(pszOp->x >> 1));
	/*******************************************************************/
	/******			common computaion for coefficent			********/
	/*******************************************************************/
	rT = (IMG_REAL)(2 * ubSkipppingMode);
	rTmp = (IMG_REAL)(ubSkipppingMode * PI);
	rDis_sm = (IMG_REAL)sin(rTmp / rT ) / rTmp;

	rTmp = (IMG_REAL)((ubSkipppingMode - 1) * PI);
	rDis_sm_sub_1 = (IMG_REAL)sin(rTmp / rT) / rTmp;

	rTmp = (IMG_REAL)((ubSkipppingMode + 1) * PI);
	rDis_sm_add_1 = (IMG_REAL)sin(rTmp / rT) / rTmp;

	rTmp = (IMG_REAL)(((ubSkipppingMode << 1) - 1) * PI);
	rDis_sm_mul2_sub_1 = (IMG_REAL)sin(rTmp / rT) / rTmp;

	rDis_1 = (IMG_REAL)(sin(PI / rT) / PI);
	rDis_0 = 1.0f / rT;

	/***********************************/
	/******			R			********/
	/***********************************/

	//coefficiengs of R
	rTmp = rDis_sm_sub_1 + rDis_sm_add_1;
	ulCoEvenRowOddR1 = (IMG_ULWORD)((rDis_sm_sub_1 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoEvenRowOddR2 = (IMG_ULWORD)((rDis_sm_add_1 / rTmp) * rFloatToFixedPoint + 0.5);

	rTmp = rDis_sm_mul2_sub_1 + rDis_1;
	ulCoEvenRowEvenR1 = (IMG_ULWORD)((rDis_sm_mul2_sub_1 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoEvenRowEvenR2 = (IMG_ULWORD)((rDis_1 / rTmp) * rFloatToFixedPoint + 0.5);

	ulCoOddRowOddR1 = ulCoEvenRowOddR1 >> 1;
	ulCoOddRowOddR2 = ulCoEvenRowOddR2 >> 1;

	ulCoOddRowEvenR1 = ulCoEvenRowEvenR1 >> 1;
	ulCoOddRowEvenR2 = ulCoEvenRowEvenR2 >> 1;

	// computaion of R
	BUF_OFF(pubS1, pubbS, pcoS);
	BUF_OFF(pubR, pubbR, pcoD);
	pubS2 = pubS1 + ulS2Linestep;
	for( j = 0; j < lwOpY; j += 2 )
	{
		// Row 0, 2, 4, 6 ...
		*pubR = *(pubS1+1);
		Bilinear_RBG_TBBoundaryB_ub2w_SSE(pubS1, puwTS, pszOp->x);
		Bilinear_RBG_TBBoundaryB_SSE(puwTS, pubR+1, lwOpX, ulHalf, ulShift,
			ulCoEvenRowOddR1, ulCoEvenRowOddR2, ulCoEvenRowEvenR1, ulCoEvenRowEvenR2);
		pubR[lwOpX+1] = pubS1[lwOpX+1];
		pubR += pubbR->linestep;

		// Row 1, 3, 5, 7 ...
		pubR[0] = (pubS1[1] + pubS2[1] + 1) >> 1;					// ">>1" = "/2" and "+1" for rounding
		Bilinear_RBG_Sum2Row_R_SSE(pubS1, pubS2, puwTS, pszOp->x);
		Bilinear_RBG_TBBoundaryB_SSE(puwTS, pubR+1, lwOpX, ulHalf, ulShift,
			ulCoOddRowOddR1, ulCoOddRowOddR2, ulCoOddRowEvenR1, ulCoOddRowEvenR2);
		pubR[lwOpX+1] = (pubS1[lwOpX+1] + pubS2[lwOpX+1] + 1) >> 1;	// ">>1" = "/2" and "+1" for rounding
		pubR += pubbR->linestep;

		pubS1 = pubS2;
		pubS2 += ulS2Linestep;
	}
	// Row M-2
	*pubR = *(pubS1+1);
	Bilinear_RBG_TBBoundaryB_ub2w_SSE(pubS1, puwTS, pszOp->x);
	Bilinear_RBG_TBBoundaryB_SSE(puwTS, pubR+1, lwOpX, ulHalf, ulShift,
			ulCoEvenRowOddR1, ulCoEvenRowOddR2, ulCoEvenRowEvenR1, ulCoEvenRowEvenR2);
	pubR[lwOpX+1] = pubS1[lwOpX+1];
	// Row M-1
	memcpy((IMG_VVOID*)(pubR+pubbR->linestep), (IMG_VVOID*)pubR, pszOp->x);

	/***********************************/
	/******			G			********/
	/***********************************/

	// coefficients of G
	rTmp1 = rDis_sm * rDis_0;
	rTmp2 = rDis_sm_sub_1 * rDis_1;
	rTmp = rTmp1 + rTmp2;
	ulCoRTLBCornerG1 = (IMG_ULWORD)((rTmp1 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoRTLBCornerG2 = (IMG_ULWORD)((rTmp2 / rTmp) * rFloatToFixedPoint + 0.5);

	rTmp3 = rDis_sm_add_1 * rDis_1;
	rTmp += rTmp1 + rTmp3;
	ulCoTLBoundaryG1 = (IMG_ULWORD)((rTmp1 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoTLBoundaryG2 = (IMG_ULWORD)((rTmp2 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoTLBoundaryG3 = (IMG_ULWORD)((rTmp3 / rTmp) * rFloatToFixedPoint + 0.5);

	rTmp4 = rDis_sm_sub_1 * rDis_sm_mul2_sub_1;
	rTmp = rTmp4 + rTmp1 + rTmp2;
	ulCoRBBoundaryEvenG1 = (IMG_ULWORD)((rTmp4 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoRBBoundaryEvenG2 = (IMG_ULWORD)((rTmp1 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoRBBoundaryEvenG3 = (IMG_ULWORD)((rTmp2 / rTmp) * rFloatToFixedPoint + 0.5);

	rTmp5 = rDis_sm_add_1 * rDis_sm_mul2_sub_1;
	rTmp = rTmp1 * 2 + rTmp4 + rTmp2 + rTmp5 + rTmp3;
	ulCoOddRowEvenG1 = (IMG_ULWORD)((rTmp1 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoOddRowEvenG2 = (IMG_ULWORD)((rTmp4 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoOddRowEvenG3 = (IMG_ULWORD)((rTmp2 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoOddRowEvenG4 = (IMG_ULWORD)((rTmp5 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoOddRowEvenG5 = (IMG_ULWORD)((rTmp3 / rTmp) * rFloatToFixedPoint + 0.5);

	ulCoEvenRowOddG1 = ulCoOddRowEvenG2;
	ulCoEvenRowOddG2 = ulCoOddRowEvenG4;
	ulCoEvenRowOddG3 = ulCoOddRowEvenG1;
	ulCoEvenRowOddG4 = ulCoOddRowEvenG3;
	ulCoEvenRowOddG5 = ulCoOddRowEvenG5;

	rTmp1 = rDis_sm * rDis_sm;
	rTmp2 = rDis_sm_sub_1 * rDis_sm_sub_1;
	rTmp = rTmp1 + rTmp2;
	ulCoRBCornerG1 = (IMG_ULWORD)((rTmp1 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoRBCornerG2 = (IMG_ULWORD)((rTmp2 / rTmp) * rFloatToFixedPoint + 0.5);

	rTmp3 = rDis_sm_add_1 * rDis_sm_sub_1;
	rTmp += rTmp1 + rTmp3;
	ulCoRBBoundaryOddG1 = (IMG_ULWORD)((rTmp1 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoRBBoundaryOddG2 = (IMG_ULWORD)((rTmp2 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoRBBoundaryOddG3 = (IMG_ULWORD)((rTmp3 / rTmp) * rFloatToFixedPoint + 0.5);

	rTmp4 = rDis_sm_add_1 * rDis_sm_add_1;
	rTmp = rTmp1 * 4 + rTmp2 + rTmp3 * 2 + rTmp4;
	ulCoOddRowOddG1 = (IMG_ULWORD)((rTmp1 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoOddRowOddG2 = (IMG_ULWORD)((rTmp2 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoOddRowOddG3 = (IMG_ULWORD)((rTmp3 / rTmp) * rFloatToFixedPoint + 0.5);
	ulCoOddRowOddG4 = (IMG_ULWORD)((rTmp4 / rTmp) * rFloatToFixedPoint + 0.5);

	// computaion of G
	BUF_OFF(pubS1, pubbS, pcoS);
	pubS2 = pubS1 + pubbS->linestep;
	BUF_OFF(pubG, pubbG, pcoD);
	// Row 0
		// Column 0~N-2
	Bilinear_GRB_G_TopLine(pubS1, pubS2, pubG, ulCoTLBoundaryG1, ulCoTLBoundaryG2, ulCoTLBoundaryG3, ulShift, ulHalf, lwOpX);
		// Column N-1
	*(pubG+lwOpX+1) = (IMG_UBYTE)((ulCoRTLBCornerG1*(*(pubS1+lwOpX)) + ulCoRTLBCornerG2*(*(pubS2+lwOpX+1)) + ulHalf) >> ulShift);
	pubG += pubbG->linestep;

	pubS3 = pubS2 + pubbS->linestep;
	pubS4 = pubS3 + pubbS->linestep;
	for( j = 1; j < lwOpY; j += 2 )
	{
	// Row 1, 3, 5, ..., M-3
		// Column 0
		*pubG = (IMG_UBYTE)((	ulCoTLBoundaryG1*(*pubS1) + ulCoTLBoundaryG2*(*(pubS2+1)) +
								ulCoTLBoundaryG1*(*pubS3) + ulCoTLBoundaryG3*(*(pubS4+1)) + ulHalf) >> ulShift);
		// Column 1 ~ N-2
		Bilinear_GRB_G_OddLine(pubS1, pubS2, pubS3, pubS4, pubG+1, ulCoOddRowOddG1, ulCoOddRowOddG2, ulCoOddRowOddG3, ulCoOddRowOddG4,
			ulCoOddRowEvenG1, ulCoOddRowEvenG2, ulCoOddRowEvenG3, ulCoOddRowEvenG4, ulCoOddRowEvenG5, ulShift, ulHalf, lwOpX);
		// Column N-1
		*(pubG+lwOpX+1) = (IMG_UBYTE)((	ulCoRBBoundaryOddG1*(*(pubS1+lwOpX)) + ulCoRBBoundaryOddG2*(*(pubS2+lwOpX+1)) +
										ulCoRBBoundaryOddG1*(*(pubS3+lwOpX)) + ulCoRBBoundaryOddG3*(*(pubS4+lwOpX+1)) + ulHalf) >> ulShift);
		pubG += pubbG->linestep;
	// Row 2, 4, 6, ..., M-2
		// Column 0 ~ N-2
		Bilinear_GRB_G_EvenLine(pubS2, pubS3, pubS4, pubG, ulCoEvenRowOddG1, ulCoEvenRowOddG2, ulCoEvenRowOddG3,
			ulCoEvenRowOddG4, ulCoEvenRowOddG5, ulShift, ulHalf, lwOpX);
		// Column N-1
		*(pubG+lwOpX+1) = (IMG_UBYTE)((ulCoRBBoundaryEvenG1*(*(pubS2+lwOpX+1)) + ulCoRBBoundaryEvenG2*(*(pubS3+lwOpX)) + ulCoRBBoundaryEvenG3*(*(pubS4+lwOpX+1)) + ulHalf) >> ulShift);

		pubG += pubbG->linestep;
		pubS1 = pubS3;
		pubS2 = pubS4;
		pubS3 += ulS2Linestep;
		pubS4 += ulS2Linestep;
	}
	// Row M-1
		// Column 0
	*pubG = (IMG_UBYTE)((ulCoRTLBCornerG1*(*pubS1) + ulCoRTLBCornerG2*(*(pubS2+1)) + ulHalf) >> ulShift);
		// Column 1 ~ N-2
	Bilinear_GRB_G_BottomLine(pubS1, pubS2, pubG+1, ulCoRBBoundaryOddG1, ulCoRBBoundaryOddG2, ulCoRBBoundaryOddG3,
		ulCoRBBoundaryEvenG2, ulCoRBBoundaryEvenG1, ulCoRBBoundaryEvenG3, ulShift, ulHalf, lwOpX);
		// Column N-1
	*(pubG+lwOpX+1) = (IMG_UBYTE)((ulCoRBCornerG1*(*(pubS1+lwOpX)) + ulCoRBCornerG2*(*(pubS2+lwOpX+1)) + ulHalf) >> ulShift);

	/***********************************/
	/******			B			********/
	/***********************************/

	// coefficients of B
	ulCoOddRowOddB1 = ulCoOddRowOddR1;
	ulCoOddRowOddB2 = ulCoOddRowOddR2;
	ulCoOddRowEvenB1 = ulCoEvenRowOddR1;
	ulCoOddRowEvenB2 = ulCoEvenRowOddR2;
	ulCoEvenRowOddB1 = ulCoOddRowEvenR1;
	ulCoEvenRowOddB2 = ulCoOddRowEvenR2;
	ulCoEvenRowEvenB1 = ulCoEvenRowEvenR1;
	ulCoEvenRowEvenB2 = ulCoEvenRowEvenR2;

	// computaion of B
	BUF_OFF(pubS1, pubbS, pcoS);
	BUF_OFF(pubB, pubbB, pcoD);
	pubS1 += pubbS->linestep;
	// Row 0
	BilinearRBG_EvenRowR_SSE(pubS1, pubB, lwOpX);
	pubS2 = pubS1 + ulS2Linestep;
	pubB += pubbB->linestep;
    for( j = 1; j < lwOpY; j += 2 )
	{
		// Row 1, 3, 5 ...
		Bilinear_GRB_InnerB_SSE(pubS1, pubS2, pubB, lwOpX, ulHalf, ulShift,
			ulCoOddRowOddB1, ulCoOddRowOddB2, ulCoOddRowEvenB1, ulCoOddRowEvenB2);
		pubB += pubbB->linestep;

		// Row 2, 4, 6 ...
		Bilinear_GRB_InnerB_SSE(pubS1, pubS2, pubB, lwOpX, ulHalf, ulShift,
			ulCoEvenRowOddB1, ulCoEvenRowOddB2, ulCoEvenRowEvenB1, ulCoEvenRowEvenB2);
		pubB += pubbB->linestep;

		pubS1 = pubS2;
		pubS2 += ulS2Linestep;
	}
	// Row M-1
	BilinearRBG_EvenRowR_SSE(pubS1, pubB, lwOpX);

	/*wStatus = MEM_PopAllHeapStatus();*/
exit:
	free(puwTS);
	return 0;
}
IMG_VVOID	DSP_Get_CPU_FEATURE(IMG_ULWORD	*pulCPU_FEATURE)
{
	__asm								//use the CPUID to determine whether the CPU support SSE2
	{
		mov		asm_si, pulCPU_FEATURE
		mov		eax, 1
		cpuid
		mov		[asm_si], edx
	}
}
IMG_VVOID	DSP_Get_SSESupport(IMG_UBYTE	*pubSSE_Support)
{
	*pubSSE_Support = ubSSE_MMX_Support;
}
static	IMG_WORD	BilinearGRB(IMG_UBBUF	const	*pubbS,
								IMG_COORD	const	*pcoS,
								IMG_UBBUF			*pubbR,
								IMG_UBBUF			*pubbG,
								IMG_UBBUF			*pubbB,
								IMG_COORD	const	*pcoD,
								IMG_SIZE	const	*pszOp,
								IMG_UBYTE	const	ubSkipppingMode)
{
	IMG_ULWORD	ulCPU_FEATURE;
	IMG_UBYTE	ubSSE_MMX_Support;
	
	// get cpu feature
	DSP_Get_CPU_FEATURE(&ulCPU_FEATURE);
	// get sse support label
	DSP_Get_SSESupport(&ubSSE_MMX_Support);
	ubSSE_MMX_Support &= ATC_EAGLE_SSE;
	return BilinearGRB_SSE(pubbS, pcoS, pubbR, pubbG, pubbB, pcoD, pszOp, ubSkipppingMode);

}
static	IMG_VVOID	MulCInPlace_ubr_C(IMG_UBBUF	*pubbBuf,
									  IMG_COORD	const *pcoOff,
									  IMG_REAL	const rFactor,
									  IMG_SIZE	const *pszOp)
{
	IMG_LWORD	i, j;
	IMG_UBYTE	*pubPtr;
	BUF_OFF(pubPtr, pubbBuf, pcoOff);
	for( j = 0; j < pszOp->y; j++ )
	{
		for( i = 0; i < pszOp->x; i++ )
		{
			*(pubPtr+i) = (IMG_UBYTE)IMG_MIN(255, *(pubPtr+i)*rFactor+0.5);
		}
		pubPtr += pubbBuf->linestep;
	}
}


IMG_WORD	DSP_MulCInPlace_ubr_SSE(IMG_UBBUF	*pubbBuf,
									IMG_COORD	const *pcoOff,
									IMG_REAL	const rFactor,	//must >= 0
									IMG_SIZE	const *pszOp)
{
	
	IMG_WORD	wStatus = OK;
	IMG_COORD	coZero={0};
	IMG_UBYTE	*pubPtr;
	IMG_REAL	*prFactor;
	IMG_ULWORD	ulBufSkip;
	IMG_LWORD	i, j, lwX, lwX1=0, lwX2;
	IMG_ULWORD	ulCPU_FEATURE;
	IMG_UBYTE	ubSSE_MMX_Support;
	IMG_REAL	arSSE[2*4];			//for prFactor
									//2 buffer is to get the 16-byte aligned address

	if( pubbBuf == NULL )
	{	wStatus = DSP_ERR_INVALID_ARG;			goto exit;	}
	if( pcoOff == NULL )			pcoOff = &coZero;
	if( pcoOff->x < 0 || pcoOff->y < 0 )
	{	wStatus = DSP_ERR_INVALID_ARG;			goto exit;	}
	if( pszOp == NULL )				pszOp = &pubbBuf->size;
	if( pcoOff->x+pszOp->x > pubbBuf->size.x ||
		pcoOff->y+pszOp->y > pubbBuf->size.y )
	{	wStatus = DSP_ERR_INVALID_ARG;			goto exit;	}
	if( rFactor < 0 )
	{	wStatus = DSP_ERR_INVALID_ARG;			goto exit;	}

	//get cpu feature
	DSP_Get_CPU_FEATURE(&ulCPU_FEATURE);
	//get sse support label
	DSP_Get_SSESupport(&ubSSE_MMX_Support); 
	ubSSE_MMX_Support &= ATC_EAGLE_SSE;
	if  ( (ulCPU_FEATURE&ATC_EAGLE_CPU_FEATURE_FOR_SSE2) == 0 || ubSSE_MMX_Support == IMG_FALSE )
	{
		MulCInPlace_ubr_C(pubbBuf, pcoOff, rFactor, pszOp);
		goto exit;
	}

	ulBufSkip = pubbBuf->linestep - pszOp->x;

	//lint -esym(550,prFactor)
	//for PC-lint
	prFactor = arSSE;
	__asm
	{
		mov			asm_ax, prFactor
		mov			asm_cx, asm_ax
		neg			asm_cx
		movd		xmm0, rFactor
		and			asm_cx, 0x0f
		add			asm_ax, asm_cx
		mov			prFactor, asm_ax			//prFactor is 16-byte aligned
		pshufd		xmm0, xmm0, 0
		movdqa		[asm_ax], xmm0
	}

	lwX = pszOp->x;
	BUF_OFF(pubPtr, pubbBuf, pcoOff);
	for( j = pszOp->y; j > 0; j-- )
	{
		__asm
		{
			mov			eax, lwX
			mov			asm_cx, pubPtr
			neg			asm_cx
			and			asm_cx, 15
			cmp			eax, ecx
			cmovg		eax, ecx
			mov			lwX1, eax
		}
		for( i = lwX1; i > 0; i-- )
		{
			*pubPtr = (IMG_UBYTE)IMG_MIN(255, ((*pubPtr) * rFactor + 0.5));
			pubPtr++;
		}
		lwX2 = (lwX-lwX1) >> 4;
		__asm
		{
			mov			eax, lwX2
			test		eax, eax
			jz			sse_over

			mov			asm_si, prFactor
			movdqa		xmm6, [asm_si]

			pxor		xmm7, xmm7

			mov			asm_si, pubPtr

sse_loop:
			movdqa		xmm0, [asm_si]			

			movdqa		xmm1, xmm0
			punpcklbw	xmm0, xmm7
			movdqa		xmm2, xmm0
			punpcklwd	xmm0, xmm7
			cvtdq2ps	xmm0, xmm0

			punpckhwd	xmm2, xmm7
			mulps		xmm0, xmm6
			punpckhbw	xmm1, xmm7
			cvtps2dq	xmm0, xmm0

			movdqa		xmm3, xmm1
			cvtdq2ps	xmm2, xmm2
			punpcklwd	xmm1, xmm7
			mulps		xmm2, xmm6
			punpckhwd	xmm3, xmm7
			cvtps2dq	xmm2, xmm2

			packssdw	xmm0, xmm2
			cvtdq2ps	xmm1, xmm1
			mulps		xmm1, xmm6
			cvtps2dq	xmm1, xmm1

			cvtdq2ps	xmm3, xmm3
			mulps		xmm3, xmm6
			cvtps2dq	xmm3, xmm3
			packssdw	xmm1, xmm3

			packuswb	xmm0, xmm1
			movdqa		[asm_si], xmm0
			add			asm_si, 16

			dec			eax
			jne			sse_loop

			mov			pubPtr, asm_si

sse_over:
		}
		for( i = lwX - lwX1 - (lwX2<<4); i > 0; i-- )
		{
			*pubPtr = (IMG_UBYTE)IMG_MIN(255, ((*pubPtr) * rFactor + 0.5));
			pubPtr++;
		}
		pubPtr += ulBufSkip;
	}

exit:
	return wStatus;
}
IMG_WORD	DSP_Bayer_Filter_Skipping(	IMG_UBBUF	const	*pubbS,					//Source bayer filter buffer
										IMG_COORD	const	*pcoS,					//Starting point of Src buffer
										IMG_SIZE	const	*pszOp,					//Size of operation region, can be null, then the size will be the size of the source image
										IMG_UBYTE	const	ubBayerPattern,			//Type of bayer pattern BG,RG etc
										IMG_UBYTE	const	ubInterpolationType,	//Type of interpolation bilinear or adaptive
										IMG_REAL	const	rWBR,					//White balance red gain
										IMG_REAL	const	rWBG,					//White balance green gain
										IMG_REAL	const	rWBB,					//White balance blue gain
										IMG_COORD	const	*pcoD,					//Starting point of Dst buffer
										IMG_UBBUF			*pubbD,					//Destination RGB buffer array
										IMG_UBYTE	const	ubSkipppingMode)		//Skipping mode
{
	IMG_WORD	wStatus = OK;
	IMG_UBBUF	ubbR, ubbG, ubbB;

	if( pubbS == NULL || pubbD == NULL || pubbS->ptr == NULL || pubbD->ptr == NULL )
	{	wStatus = DSP_ERR_INVALID_ARG;		goto exit;	}
	if( pcoS == NULL || pcoD == NULL || pszOp == NULL )
	{	wStatus = DSP_ERR_INVALID_ARG;		goto exit;	}
	if( pcoS->x < 0 || pcoS->y < 0 || pcoD->x < 0 || pcoD->y < 0 )
	{	wStatus = DSP_ERR_INVALID_ARG;		goto exit;	}
	if( (pcoS->x & 1) == 1 || (pcoS->y & 1) == 1 ||
		(pszOp->x & 1) == 1 || (pszOp->y & 1) == 1 )
	{	wStatus = DSP_ERR_INVALID_ARG;		goto exit;	}
	if( pcoS->x + pszOp->x > pubbS->size.x || pcoS->y + pszOp->y > pubbS->size.y )
	{	wStatus = DSP_ERR_INVALID_ARG;		goto exit;	}
	if( pcoD->x + pszOp->x > pubbD->size.x || pcoD->y + pszOp->y > pubbD->size.y )
	{	wStatus = DSP_ERR_INVALID_ARG;		goto exit;	}
	if( pszOp->x < 2 || pszOp->y < 2 )
	{	wStatus = DSP_ERR_INVALID_ARG;		goto exit;	}

	ubbR = *pubbD;
	ubbG = *(pubbD+1);
	ubbB = *(pubbD+2);
	switch(ubInterpolationType)
	{
		case	DSP_BILINEAR_CBF:
			
			switch(ubBayerPattern)
			{
				/*case	DSP_BAYER_RGBG:
					wStatus = BilinearRBG(pubbS, pcoS, &ubbR, &ubbG, &ubbB, pcoD, pszOp, ubSkipppingMode);
					if( wStatus != OK )				goto exit;
					break;
				case	DSP_BAYER_BGRG:
					wStatus = BilinearRBG(pubbS, pcoS, &ubbB, &ubbG, &ubbR, pcoD, pszOp, ubSkipppingMode);
					if( wStatus != OK )				goto exit;
					break;*/
				case	DSP_BAYER_GRGB:
					wStatus = BilinearGRB(pubbS, pcoS, &ubbR, &ubbG, &ubbB, pcoD, pszOp, ubSkipppingMode);
					if( wStatus != OK )				goto exit;
					break;
				/*case	DSP_BAYER_GBGR:
					wStatus = BilinearGRB(pubbS, pcoS, &ubbB, &ubbG, &ubbR, pcoD, pszOp, ubSkipppingMode);
					if( wStatus != OK )				goto exit;
					break;*/
				default:
					break;
			}
			break;
		case	DSP_ADAPTIVE_CBF:
			wStatus = DSP_ERR_INVALID_ARG;
			goto exit;
	
		default:
			wStatus = DSP_ERR_INVALID_ARG;
			goto exit;
			//break;
	}

	if(fabs(rWBR-1) > 0.0001)			// white balance red gain, if the value is 1, then skip the computation
	{
		wStatus = DSP_MulCInPlace_ubr_SSE(pubbD, pcoD, rWBR, pszOp);
		if( wStatus != OK )				goto exit;
	}
	if(fabs(rWBG-1) > 0.0001)			// same as rWBR	
	{
		wStatus = DSP_MulCInPlace_ubr_SSE(pubbD+1, pcoD, rWBG, pszOp);
		if( wStatus != OK )				goto exit;
	}
	if(fabs(rWBB-1) > 0.0001)			// same as rWBR
	{   
		wStatus = DSP_MulCInPlace_ubr_SSE(pubbD+2, pcoD, rWBB, pszOp);
		if( wStatus != OK )				goto exit;
	}

exit:
	return wStatus;
}
IMG_WORD	DSP_Bayer_Filter_Skipping_FullSupport(	IMG_UBBUF	const	*pubbS,					//Source bayer filter buffer
													IMG_COORD	const	*pcoS,					//Starting point of Src buffer
													IMG_SIZE	const	*pszOp,					//Size of operation region, can be null, then the size will be the size of the source image
													IMG_UBYTE	const	ubOriginalBayerPattern,	//Type of bayer pattern DSP_BAYER_RGBG, DSP_BAYER_GRGB etc, this pattern is corresponding to the original coordinate of the sensor array
													IMG_UBYTE	const	ubCutXOdd,				//If the cutting offset coCutOff.x is an odd number, then ubCutXOdd = 1, else ubCutXOdd = 0, can pass (coCutOff.x & 1) to this function
													IMG_UBYTE	const	ubCutYOdd,				//If the cutting offset coCutOff.y is an odd number, then ubCutYOdd = 1, else ubCutYOdd = 0, can pass (coCutOff.y & 1) to this function
																								//The cutting offset coCutOff is the offset between the original coordinate of the source buffer(pubbS) and the original coordinate of the sensor array
													IMG_UBYTE	const	ubInterpolationType,	//Type of interpolation bilinear or adaptive
													IMG_REAL	const	rWBR,					//White balance red gain
													IMG_REAL	const	rWBG,					//White balance green gain
													IMG_REAL	const	rWBB,					//White balance blue gain
													IMG_COORD	const	*pcoD,					//Starting point of Dst buffer
													IMG_UBBUF			*pubbD,					//Destination RGB buffer array
													IMG_UBYTE	const	ubSkipppingMode)		//Skipping mode
{
	IMG_WORD	wStatus, wPop;
	IMG_COORD	coTmpMainSrc, coTmpMainDst, coZero = {0}, coTmpBoundarySrc, coTmpBoundaryDst;
	IMG_SIZE	szTmpMain, szTmpBoundary;
	IMG_UBBUF	ubbTmpSrc, aubbTmpDst[3], ubbTmp;
	IMG_UBYTE	ubPattern = 0;

	/*wStatus = MEM_PushAllHeapStatus();
	if( wStatus != OK )			goto exit;*/

	if( ubSkipppingMode == 0 )
	{
		wStatus = DSP_ERR_INVALID_ARG;
		goto exit;
	}
	if( pcoS->x < 0 || pcoS->y < 0 )
	{
		wStatus = DSP_ERR_INVALID_ARG;
		goto exit;
	}
	if( ((ubCutXOdd + (pcoS->x & 1)) & 1) + ((ubCutYOdd + (pcoS->y & 1)) & 1) + (pszOp->x & 1) + (pszOp->y & 1) == 0 )
	{
		BUF_OFF(ubbTmpSrc.ptr, pubbS, pcoS);
		ubbTmpSrc.linestep = pubbS->linestep;
		ubbTmpSrc.size = pubbS->size;
		wStatus = DSP_Bayer_Filter_Skipping(&ubbTmpSrc, &coZero, pszOp, ubOriginalBayerPattern,
			ubInterpolationType, rWBR, rWBG, rWBB, pcoD, pubbD, ubSkipppingMode);
		// goto exit;
	}
exit:
	/*wPop = MEM_PopAllHeapStatus();
	if( wStatus != OK )		return wStatus;*/
	return 0;
}
int _tmain(int argc, _TCHAR* argv[])
{
	IMG_UBBUF		ubbRaw, aubbD[3];
	IMG_SIZE		szImg = {496, 466};
	IMG_COORD		coZero = {0};

	ubbRaw.size = szImg;
	ubbRaw.linestep = szImg.x;
	ubbRaw.ptr = (IMG_UBYTE*)malloc(sizeof(IMG_UBYTE) * szImg.x * szImg.y);

	for (int i = 0; i < 32; ++i)
	{
		IMG_UBYTE	*pubT1 = NULL, *pubT2 = NULL, *pubT3 = NULL;
		IMG_WORD	wStatus = 0;
		aubbD[0].size = szImg;
		aubbD[0].linestep = 2560;
		pubT1 = (IMG_UBYTE*)malloc(sizeof(IMG_UBYTE) * (szImg.y + 1) * aubbD[0].linestep);
		aubbD[0].ptr = pubT1 + i;
		aubbD[1] = aubbD[0];
		pubT2 = (IMG_UBYTE*)malloc(sizeof(IMG_UBYTE) * (szImg.y + 1) * aubbD[1].linestep);
		aubbD[1].ptr = pubT2 + i;
		aubbD[2] = aubbD[0];
		pubT3 = (IMG_UBYTE*)malloc(sizeof(IMG_UBYTE) * (szImg.y + 1) * aubbD[2].linestep);
		aubbD[2].ptr = pubT3 + i;

		wStatus = DSP_Bayer_Filter_Skipping_FullSupport(&ubbRaw, &coZero, &szImg, 1, 0, 0, 0, 1.1, 1.2, 1.1, &coZero, aubbD, 4);

		free(pubT1);
		free(pubT2);
		free(pubT3);
	}
	free(ubbRaw.ptr);
	
	return 0;
}

